#!/bin/bash
THREADS=64
#SEARCH_DIR=/home/pvekris/deadlock2/src
SEARCH_DIR=/usr/share
REGEXP=program
TMP_FILE=tmp1
TIMES=10

echo "The search directory contains `find $SEARCH_DIR -type f -print | wc -l` files."
rm -f $TMP_FILE results1.txt results2.txt

# warming the cache...
printf "warming up... "
TGLIMIT=$THREADS time -f "%U %S" ./tgrep -B $REGEXP $SEARCH_DIR >OUT.vanilla
sort OUT.vanilla > SORT
mv -f SORT OUT.vanilla

RESULTS=results1.txt
TMP_RESULTS=tmp_results.txt

rm -f $RESULTS 
rm -f $TMP_RESULTS 
for ((i=1 ; i <= $THREADS  ; i*=2)) do
  sum1=0; sum2=0; sum3=0; sum4=0; sum5=0
  for ((j=1 ; j <= $TIMES  ; j+=1)) do
    printf "vanilla, $i thread(s) "
    TGLIMIT=$i time -o $TMP_FILE -f "%U %S %e" ./tgrep -B $REGEXP $SEARCH_DIR >OUT.$i
    cat $TMP_FILE
    sort OUT.$i > SORT
    mv -f SORT OUT.$i
    awk -v it=$i '{print it, " ", $3, $1+$2, " ", $0;}' $TMP_FILE >> $TMP_RESULTS
    diff -q OUT.$i OUT.vanilla && rm -f OUT.$i
    rm -f $TMP_FILE
  done
  awk -v it=$i -v n="$TIMES" \
    '{sum1+= $2; sum2+=$3; sum3+=$4; sum4+=$5; sum5+=$6} \
     END{ print it " " sum1/n " " sum2/n " " sum3/n " " sum4/n " " sum5/n }' \
     $TMP_RESULTS >> $RESULTS
  echo "------------------------------------"  
  rm -f $TMP_RESULTS 
done

RESULTS=results2.txt
TMP_RESULTS=tmp_results.txt

rm -f $RESULTS 
rm -f $TMP_RESULTS 
for ((i=1 ; i <= $THREADS  ; i*=2)) do
  sum1=0; sum2=0; sum3=0; sum4=0; sum5=0
  for ((j=1 ; j <= $TIMES  ; j+=1)) do
    printf "vanilla, $i thread(s) "
    TGLIMIT=$i time -o $TMP_FILE -f "%U %S %e" ./tgrep_mod -B $REGEXP $SEARCH_DIR >OUT.$i
    cat $TMP_FILE
    sort OUT.$i > SORT
    mv -f SORT OUT.$i
    awk -v it=$i '{print it, " ", $3, $1+$2, " ", $0;}' $TMP_FILE >> $TMP_RESULTS
    diff -q OUT.$i OUT.vanilla && rm -f OUT.$i
    rm -f $TMP_FILE
  done
  awk -v it=$i -v n="$TIMES" \
    '{sum1+= $2; sum2+=$3; sum3+=$4; sum4+=$5; sum5+=$6} \
     END{ print it " " sum1/n " " sum2/n " " sum3/n " " sum4/n " " sum5/n }' \
     $TMP_RESULTS >> $RESULTS
  echo "------------------------------------"  
  rm -f $TMP_RESULTS 
done

